"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadBlockStateDefinition = loadBlockStateDefinition;
exports.loadModel = loadModel;
const deepmerge_1 = __importDefault(require("deepmerge"));
function loadBlockStateDefinition(block, resourceLoader) {
    return __awaiter(this, void 0, void 0, function* () {
        return JSON.parse(yield resourceLoader.getResourceString(`blockstates/${block}.json`));
    });
}
function loadModel(modelRef, resourceLoader) {
    return __awaiter(this, void 0, void 0, function* () {
        if (modelRef.startsWith('minecraft:')) {
            modelRef = modelRef.substring('minecraft:'.length);
        }
        let model = JSON.parse(yield resourceLoader.getResourceString(`models/${modelRef}.json`));
        if (model.parent) {
            const parent = yield loadModel(model.parent, resourceLoader);
            if (model['elements'] && parent['elements']) {
                delete parent['elements'];
            }
            model = (0, deepmerge_1.default)(parent, model);
            delete model.parent;
        }
        return model;
    });
}
//# sourceMappingURL=parser.js.map